package pocket_test

import (
	"gitlab.com/auroq/advent-of-code/advent-of-code-2020/pkg/challenges/day20/pocket"
	"reflect"
	"testing"
)

func TestGrid_Positions(t *testing.T) {
	image := pocket.NewImage([]string{
		"Tile 2311:",
		"..##.#..#.",
		"##..#.....",
		"#...##..#.",
		"####.#...#",
		"##.##.###.",
		"##...#.###",
		".#.#.#..##",
		"..#....#..",
		"###...#.#.",
		"..###..###",
		"",
		"Tile 1951:",
		"#.##...##.",
		"#.####...#",
		".....#..##",
		"#...######",
		".##.#....#",
		".###.#####",
		"###.##.##.",
		".###....#.",
		"..#.#..#.#",
		"#...##.#..",
		"",
		"Tile 1171:",
		"####...##.",
		"#..##.#..#",
		"##.#..#.#.",
		".###.####.",
		"..###.####",
		".##....##.",
		".#...####.",
		"#.##.####.",
		"####..#...",
		".....##...",
		"",
		"Tile 1427:",
		"###.##.#..",
		".#..#.##..",
		".#.##.#..#",
		"#.#.#.##.#",
		"....#...##",
		"...##..##.",
		"...#.#####",
		".#.####.#.",
		"..#..###.#",
		"..##.#..#.",
		"",
		"Tile 1489:",
		"##.#.#....",
		"..##...#..",
		".##..##...",
		"..#...#...",
		"#####...#.",
		"#..#.#.#.#",
		"...#.#.#..",
		"##.#...##.",
		"..##.##.##",
		"###.##.#..",
		"",
		"Tile 2473:",
		"#....####.",
		"#..#.##...",
		"#.##..#...",
		"######.#.#",
		".#...#.#.#",
		".#########",
		".###.#..#.",
		"########.#",
		"##...##.#.",
		"..###.#.#.",
		"",
		"Tile 2971:",
		"..#.#....#",
		"#...###...",
		"#.#.###...",
		"##.##..#..",
		".#####..##",
		".#..####.#",
		"#..#.#..#.",
		"..####.###",
		"..#.#.###.",
		"...#.#.#.#",
		"",
		"Tile 2729:",
		"...#.#.#.#",
		"####.#....",
		"..#.#.....",
		"....#..#.#",
		".##..##.#.",
		".#.####...",
		"####.#.#..",
		"##.####...",
		"##..#.##..",
		"#.##...##.",
		"",
		"Tile 3079:",
		"#.#.#####.",
		".#..######",
		"..#.......",
		"######....",
		"####.#..#.",
		".#...#.##.",
		"#.#####.##",
		"..#.###...",
		"..#.......",
		"..#.###...",
	})
	// Two possible options depending on ordering of map
	expectedOptionOne := map[pocket.Position]string{
		{2, 2}: "1951",
		{1, 2}: "2311",
		{0, 2}: "3079",
		{2, 1}: "2729",
		{1, 1}: "1427",
		{0, 1}: "2473",
		{2, 0}: "2971",
		{1, 0}: "1489",
		{0, 0}: "1171",
	}
	expectedOptionTwo := map[pocket.Position]string{
		{2, 2}: "1951",
		{1, 2}: "2729",
		{0, 2}: "2971",
		{2, 1}: "2311",
		{1, 1}: "1427",
		{0, 1}: "1489",
		{2, 0}: "3079",
		{1, 0}: "2473",
		{0, 0}: "1171",
	}
	positionsString := func(positions map[pocket.Position]string) (str string) {
		for y := 0; y < 3; y++ {
			for x := 0; x < 3; x++ {
				str += positions[pocket.Position{X: x, Y: y}] + " "
			}
			str += "\n"
		}
		return
	}

	actual := image.Positions()

	fail := func(position pocket.Position, expectedVal, actualVal string) {
		t.Fatalf(
			"expected:\n%s- OR -\n%s\nactual:\n%s\nIncorrectKey: %s\nExpected: %s\nActual: %s",
			positionsString(expectedOptionOne),
			positionsString(expectedOptionTwo),
			positionsString(actual),
			position,
			expectedVal,
			actualVal)
	}

	complete := true
	for key, expectedVal := range expectedOptionOne {
		if actualVal := actual[key]; actualVal != expectedVal {
			complete = false
			break // It is not option one. Try option two
		}
	}
	if !complete {
		for key, expectedVal := range expectedOptionTwo {
			if actualVal := actual[key]; actualVal != expectedVal {
				fail(key, expectedVal, actualVal)
			}
		}
	}
}

func TestGrid_Transformations(t *testing.T) {
	image := pocket.NewImage([]string{
		"Tile 2311:",
		"..##.#..#.",
		"##..#.....",
		"#...##..#.",
		"####.#...#",
		"##.##.###.",
		"##...#.###",
		".#.#.#..##",
		"..#....#..",
		"###...#.#.",
		"..###..###",
		"",
		"Tile 1951:",
		"#.##...##.",
		"#.####...#",
		".....#..##",
		"#...######",
		".##.#....#",
		".###.#####",
		"###.##.##.",
		".###....#.",
		"..#.#..#.#",
		"#...##.#..",
		"",
		"Tile 1171:",
		"####...##.",
		"#..##.#..#",
		"##.#..#.#.",
		".###.####.",
		"..###.####",
		".##....##.",
		".#...####.",
		"#.##.####.",
		"####..#...",
		".....##...",
		"",
		"Tile 1427:",
		"###.##.#..",
		".#..#.##..",
		".#.##.#..#",
		"#.#.#.##.#",
		"....#...##",
		"...##..##.",
		"...#.#####",
		".#.####.#.",
		"..#..###.#",
		"..##.#..#.",
		"",
		"Tile 1489:",
		"##.#.#....",
		"..##...#..",
		".##..##...",
		"..#...#...",
		"#####...#.",
		"#..#.#.#.#",
		"...#.#.#..",
		"##.#...##.",
		"..##.##.##",
		"###.##.#..",
		"",
		"Tile 2473:",
		"#....####.",
		"#..#.##...",
		"#.##..#...",
		"######.#.#",
		".#...#.#.#",
		".#########",
		".###.#..#.",
		"########.#",
		"##...##.#.",
		"..###.#.#.",
		"",
		"Tile 2971:",
		"..#.#....#",
		"#...###...",
		"#.#.###...",
		"##.##..#..",
		".#####..##",
		".#..####.#",
		"#..#.#..#.",
		"..####.###",
		"..#.#.###.",
		"...#.#.#.#",
		"",
		"Tile 2729:",
		"...#.#.#.#",
		"####.#....",
		"..#.#.....",
		"....#..#.#",
		".##..##.#.",
		".#.####...",
		"####.#.#..",
		"##.####...",
		"##..#.##..",
		"#.##...##.",
		"",
		"Tile 3079:",
		"#.#.#####.",
		".#..######",
		"..#.......",
		"######....",
		"####.#..#.",
		".#...#.##.",
		"#.#####.##",
		"..#.###...",
		"..#.......",
		"..#.###...",
	})

	expectedTransformations := map[string][]pocket.Transformation{
		"1951": {pocket.FlipX}, //{pocket.Half, pocket.FlipY}, //FlipX
		"2311": {pocket.FlipX}, //{pocket.Half, pocket.FlipY}, //FlipX
		"3079": nil,
		"2729": {pocket.FlipX}, //{pocket.Half, pocket.FlipY}, //FlipX
		"1427": {pocket.FlipX}, //{pocket.Half, pocket.FlipY}, //FlipX
		"2473": {pocket.Clockwise, pocket.FlipX},
		"2971": {pocket.FlipX}, //{pocket.Half, pocket.FlipY}, //FlipX
		"1489": {pocket.FlipX}, //{pocket.Half, pocket.FlipY}, //FlipX
		"1171": {pocket.FlipY}, //{pocket.Half, pocket.FlipX}, //FlipY
	}

	image.SetPositions(map[pocket.Position]string{
		{X: 0, Y: 0}: "1951",
		{X: 1, Y: 0}: "2311",
		{X: 2, Y: 0}: "3079",
		{X: 0, Y: 1}: "2729",
		{X: 1, Y: 1}: "1427",
		{X: 2, Y: 1}: "2473",
		{X: 0, Y: 2}: "2971",
		{X: 1, Y: 2}: "1489",
		{X: 2, Y: 2}: "1171",
	})
	actualTransformations := image.Transformations()
	for id, expected := range expectedTransformations {
		if actual, ok := actualTransformations[id]; !ok {
			t.Errorf("id expected: %s but was not found in actual", id)
		} else if !reflect.DeepEqual(actual, expected) {
			t.Errorf("id: %s expected: %v actual:%v", id, expected, actual)
		}
	}
}

func TestGrid_Assembled(t *testing.T) {
	image := pocket.NewImage([]string{
		"Tile 2311:",
		"..##.#..#.",
		"##..#.....",
		"#...##..#.",
		"####.#...#",
		"##.##.###.",
		"##...#.###",
		".#.#.#..##",
		"..#....#..",
		"###...#.#.",
		"..###..###",
		"",
		"Tile 1951:",
		"#.##...##.",
		"#.####...#",
		".....#..##",
		"#...######",
		".##.#....#",
		".###.#####",
		"###.##.##.",
		".###....#.",
		"..#.#..#.#",
		"#...##.#..",
		"",
		"Tile 1171:",
		"####...##.",
		"#..##.#..#",
		"##.#..#.#.",
		".###.####.",
		"..###.####",
		".##....##.",
		".#...####.",
		"#.##.####.",
		"####..#...",
		".....##...",
		"",
		"Tile 1427:",
		"###.##.#..",
		".#..#.##..",
		".#.##.#..#",
		"#.#.#.##.#",
		"....#...##",
		"...##..##.",
		"...#.#####",
		".#.####.#.",
		"..#..###.#",
		"..##.#..#.",
		"",
		"Tile 1489:",
		"##.#.#....",
		"..##...#..",
		".##..##...",
		"..#...#...",
		"#####...#.",
		"#..#.#.#.#",
		"...#.#.#..",
		"##.#...##.",
		"..##.##.##",
		"###.##.#..",
		"",
		"Tile 2473:",
		"#....####.",
		"#..#.##...",
		"#.##..#...",
		"######.#.#",
		".#...#.#.#",
		".#########",
		".###.#..#.",
		"########.#",
		"##...##.#.",
		"..###.#.#.",
		"",
		"Tile 2971:",
		"..#.#....#",
		"#...###...",
		"#.#.###...",
		"##.##..#..",
		".#####..##",
		".#..####.#",
		"#..#.#..#.",
		"..####.###",
		"..#.#.###.",
		"...#.#.#.#",
		"",
		"Tile 2729:",
		"...#.#.#.#",
		"####.#....",
		"..#.#.....",
		"....#..#.#",
		".##..##.#.",
		".#.####...",
		"####.#.#..",
		"##.####...",
		"##..#.##..",
		"#.##...##.",
		"",
		"Tile 3079:",
		"#.#.#####.",
		".#..######",
		"..#.......",
		"######....",
		"####.#..#.",
		".#...#.##.",
		"#.#####.##",
		"..#.###...",
		"..#.......",
		"..#.###...",
	})
	expectedLines := []string{
		".#.#..#.##...#.##..#####",
		"###....#.#....#..#......",
		"##.##.###.#.#..######...",
		"###.#####...#.#####.#..#",
		"##.#....#.##.####...#.##",
		"...########.#....#####.#",
		"....#..#...##..#.#.###..",
		".####...#..#.....#......",
		"#..#.##..#..###.#.##....",
		"#.####..#.####.#.#.###..",
		"###.#.#...#.######.#..##",
		"#.####....##..########.#",
		"##..##.#...#...#.#.#.#..",
		"...#..#..#.#.##..###.###",
		".#.#....#.##.#...###.##.",
		"###.#...#..#.##.######..",
		".#.#.###.##.##.#..#.##..",
		".####.###.#...###.#..#.#",
		"..#.#..#..#.#.#.####.###",
		"#..####...#.#.#.###.###.",
		"#####..#####...###....##",
		"#.##..#..#...#..####...#",
		".#.###..##..##..####.##.",
		"...###...##...#...#..###",
	}

	image.SetPositions(map[pocket.Position]string{
		{X: 0, Y: 0}: "1951",
		{X: 1, Y: 0}: "2311",
		{X: 2, Y: 0}: "3079",
		{X: 0, Y: 1}: "2729",
		{X: 1, Y: 1}: "1427",
		{X: 2, Y: 1}: "2473",
		{X: 0, Y: 2}: "2971",
		{X: 1, Y: 2}: "1489",
		{X: 2, Y: 2}: "1171",
	})
	actual := image.Assembled()
	expected := pocket.NewGrid(expectedLines)
	if !actual.Equals(expected) {
		t.Fatalf("expected:\n%s\n\nactual:\n%s", expected, actual)
	}
}

func TestGroupGrids(t *testing.T) {
	grid1 := pocket.NewGrid([]string{
		"#.",
		".#",
	})
	grid2 := pocket.NewGrid([]string{
		".#",
		"#.",
	})
	grids := map[pocket.Position]pocket.Grid{
		pocket.Position{X: 0, Y: 0}: grid1.Copy(),
		pocket.Position{X: 1, Y: 0}: grid2.Copy(),
		pocket.Position{X: 2, Y: 0}: grid1.Copy(),
		pocket.Position{X: 0, Y: 1}: grid2.Copy(),
		pocket.Position{X: 1, Y: 1}: grid1.Copy(),
		pocket.Position{X: 2, Y: 1}: grid2.Copy(),
		pocket.Position{X: 0, Y: 2}: grid1.Copy(),
		pocket.Position{X: 1, Y: 2}: grid2.Copy(),
		pocket.Position{X: 2, Y: 2}: grid1.Copy(),
	}
	expected := pocket.NewGrid([]string{
		"#..##.",
		".##..#",
		".##..#",
		"#..##.",
		"#..##.",
		".##..#",
	})
	actual := pocket.GroupGrids(grids, pocket.Dimensions{
		X: pocket.Dimension{Min: 0, Max: 2},
		Y: pocket.Dimension{Min: 0, Max: 2},
	})
	if !actual.Equals(expected) {
		t.Fatalf("expected:\n%s\n\nactual:\n%s", expected, actual)
	}
}
